'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.guest = exports.user = exports.active = exports.admin = undefined;

var _tokens = require('./tokens');

var admin = exports.admin = { icon: 'gear',
  stateKeys: ['user', 'user.admin'],
  subscriptions: [{
    collectionName: '*'
  }],
  tokens: [_tokens.stateModeToken]
};

var active = exports.active = { stateKeys: ['user', 'user.email', 'user.active'],
  tokens: [_tokens.stateModeToken]
};

var user = exports.user = { icon: 'user',
  stateKeys: ['user', 'user.email'],
  tokens: [_tokens.stateModeToken]
};

var guest = exports.guest = { icon: 'guest',
  isSkipJwt: true,
  subscriptions: [{
    collectionName: 'users',
    tokens: [_tokens.userSubscriptionToken]
  }]
};