'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSign = useSign;

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _compression = require('compression');

var _compression2 = _interopRequireDefault(_compression);

var _cookieParser = require('cookie-parser');

var _cookieParser2 = _interopRequireDefault(_cookieParser);

var _connectFlash = require('connect-flash');

var _connectFlash2 = _interopRequireDefault(_connectFlash);

var _expressSession = require('express-session');

var _expressSession2 = _interopRequireDefault(_expressSession);

var _passport = require('passport');

var _passport2 = _interopRequireDefault(_passport);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MongoStore = require('connect-mongo')(_expressSession2.default);
function useSign(app, config) {
  // unpack
  var db = config.db,
      isProd = config.isProd,
      _config$session = config.session,
      expiry = _config$session.expiry,
      key = _config$session.key,
      secret = _config$session.secret;
  // store

  var store = new MongoStore({
    db: db,
    ttl: expiry
  });
  // set up sessions, requires for auth (via passport)
  var sess = {
    cookie: { maxAge: expiry },
    key: key,
    secret: secret,
    store: store,
    resave: false,
    saveUninitialized: false
  };
  if (isProd) {
    app.set('trust proxy', 1);
    sess.cookie.secure = true;
  }
  // use
  app.use((0, _cookieParser2.default)('keyboard cat')); // read cookies - needed for flash messages
  app.use((0, _connectFlash2.default)()); // flash messages, used for login/signup errors
  app.use(_bodyParser2.default.urlencoded({ extended: true }));
  app.use(_bodyParser2.default.json());
  app.use((0, _expressSession2.default)(sess));
  app.use(_passport2.default.initialize());
  app.use(_passport2.default.session()); // persistent login sessions
  app.use((0, _compression2.default)());
}