'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.userSubscriptionToken = exports.stateModeToken = undefined;

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var queryMethods = ['GET', 'PUT', 'DELETE'];

var stateModeToken = exports.stateModeToken = function stateModeToken(_ref, state) {
  var stateKeys = _ref.stateKeys;

  // console.log('stateKeys', stateKeys, state.user)
  return !stateKeys || stateKeys.every(function (stateKey) {
    return (0, _lodash2.default)(state, stateKey);
  });
};

var userSubscriptionToken = exports.userSubscriptionToken = function userSubscriptionToken(_ref2, _ref3) {
  var getQuery = _ref2.getQuery;
  var method = _ref3.method,
      option = _ref3.option,
      user = _ref3.user;

  // switch given the method
  var joins = queryMethods.includes(method) ? [option.query] : method === 'POST' ? option.documents : null;
  // add extra Query
  if (getQuery) {
    joins = joins.map(function (join) {
      return getQuery(join, { user: user });
    });
  }
  // test
  return user && joins && joins.every(function (_ref4) {
    var userId = _ref4.userId;
    return userId === user.id;
  });
};