'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTour = undefined;

var useTour = exports.useTour = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(app, config) {
    var db, localAuthenticateAndRedirect, returnTo, routePath, getFormatUser, adminUser, tours, users, adminTour;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            // unpack
            db = config.db, localAuthenticateAndRedirect = config.localAuthenticateAndRedirect, returnTo = config.returnTo, routePath = config.routePath;
            getFormatUser = config.getFormatUser || _format.getFormatUser;
            adminUser = config.adminUser;
            tours = void 0;
            users = config.users;
            // use

            app.use(_bodyParser2.default.json()); // to support JSON-encoded bodies
            // check for the users

            if (!(db && !users)) {
              _context2.next = 16;
              break;
            }

            _context2.next = 9;
            return db.collection('tours').find().toArray();

          case 9:
            tours = _context2.sent;
            _context2.next = 12;
            return Promise.all(tours.map(function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(tour) {
                var user;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.t0 = getFormatUser;
                        _context.next = 3;
                        return db.collection('users').findOne({ id: tour.userId });

                      case 3:
                        _context.t1 = _context.sent;
                        user = (0, _context.t0)(_context.t1);

                        user.modeName = tour.modeName;
                        return _context.abrupt('return', user);

                      case 7:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, this);
              }));

              return function (_x3) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 12:
            users = _context2.sent;

            // search for admin user
            adminTour = tours.find(function (_ref3) {
              var modeName = _ref3.modeName;
              return modeName === 'admin';
            });

            adminUser = Object.assign({}, users.find(function (_ref4) {
              var modeName = _ref4.modeName;
              return modeName === 'admin';
            }));
            if (adminUser && adminTour) {
              adminUser.password = adminTour.password;
            }

          case 16:
            // automatic signin with a mock user
            app.post(routePath, function (req, res, next) {
              // determine which tour user to use given the password
              var matchedUser = users.find(function (_ref5) {
                var email = _ref5.email;
                return email === req.body.email;
              });
              // if find then pass the password
              if (matchedUser) {
                var password = matchedUser.password;
                if (!password && tours) {
                  var matchedTour = tours.find(function (_ref6) {
                    var userId = _ref6.userId;
                    return userId === matchedUser.id;
                  });
                  if (matchedTour) {
                    password = matchedTour.password;
                  }
                }
                if (password) {
                  req.body.password = password;
                } else {
                  console.warn('transactions-express-passport tour: did not find such tour');
                }
              } else {
                console.warn('transactions-express-passport tour: did not find such user ' + email);
              }
              // next
              next();
            }, returnTo, localAuthenticateAndRedirect);
            // return
            return _context2.abrupt('return', { adminUser: adminUser,
              users: users
            });

          case 18:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function useTour(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

var _format = require('./format');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }